#property copyright "Copyright  2011, Murad Ismayilov"
#property link      "http://www.mql4.com/ru/users/wmlab/"

#include <stdlib.mqh>
#include <stderror.mqh>

//
//   ()
//

extern int ChannelPipsD5 = 100; //  

//
//   ( )
//

extern string S0 = "---   ---";

extern double Lots = 0.01; //  
extern double MaxLots = 5.00; //  
extern double MinEquity = 500.0; //     
extern bool DoComments = true; //    
extern bool DoGraphs = true; //    
extern bool DoSound = true; //    
extern int MagicNumber = 110518;
extern color ColorBuy = RoyalBlue;
extern color ColorSell = Tomato;

//
//  
//

bool IsExpertFailed = false;
bool IsExpertStopped = false;
int SlipPipsD5 = 30;
int NumberOfTry = 5;
datetime LastClear;


//+------------------------------------------------------------------+
//|                                                       |
//+------------------------------------------------------------------+

int init()
{
   IsExpertStopped = false;
   if (!IsTradeAllowed())
   {
      Comment("   ");
      IsExpertStopped = true;
      return (0);
   }
      
   if (!IsTesting())
   {
      if (IsExpertEnabled())
      {
         Comment("    ");
      }
      else 
      {
         Comment("  \"  \"");
      }
   }
   else
   {
      WmLoadHistory(Period());
   }   
         
   LastClear = TimeCurrent();
      
   return (0);
}

//+------------------------------------------------------------------+
//|                                            |
//+------------------------------------------------------------------+

int deinit()
{
   return (0);
}

//+------------------------------------------------------------------+
//|                                                  |
//+------------------------------------------------------------------+
  
int start() 
{
   if (IsExpertStopped)
   {
      Comment("   !");
      return (0);
   }
   
   if (IsExpertFailed)
   {
      Comment(" !  .");
      return (0);
   }
      
   //   
   
   if (DoGraphs)
   {   
      if ((TimeCurrent() - LastClear) >= 60)
      {
         //  
      
         LastClear = TimeCurrent();
         WmClearAndDraw(MagicNumber);
      }
   }
   
   //     
   
   int orders = 0;
   double profit = 0.0;
   int countBuy = 0, countSell = 0;
   int countBuyStop = 0, countSellStop = 0;
   double priceBuy = 0.0, priceSell = 0.0;
   double lotsBuy = 0.0, lotsSell = 0.0;
   int orderType;
   for (int orderIndex = (OrdersTotal() - 1); orderIndex >= 0; orderIndex--)
   {
      if (!OrderSelect(orderIndex, SELECT_BY_POS))
      {
         continue;
      }

      if (OrderSymbol() != Symbol())
      {
         continue;
      }
   
      if (OrderMagicNumber() != MagicNumber)
      {
         continue;
      }

      orders++;      
      orderType = OrderType();
      switch(orderType)
      {
         case OP_BUY:
            priceBuy = OrderOpenPrice();
            lotsBuy += OrderLots();
            countBuy++;
            profit += OrderProfit() + OrderSwap();
            break;
         case OP_SELL:
            priceSell = OrderOpenPrice();
            lotsSell += OrderLots();
            countSell++;
            profit += OrderProfit() + OrderSwap();
            break;
         case OP_BUYSTOP:
            priceBuy = OrderOpenPrice();
            lotsBuy += OrderLots();         
            countBuyStop++;
            break;
         case OP_SELLSTOP:
            priceSell = OrderOpenPrice();
            lotsSell += OrderLots();
            countSellStop++;
            break;
      }
   }
   
   //   
   
   double equity = AccountEquity();
   double drilldown = 0.0;
   if (orders > 0)
   {
      drilldown = MathAbs((profit * 100.0) / equity);
   }
   
   //  
   
   if (equity < MinEquity)
   {
      WmCloseAllOrders(MagicNumber);
      IsExpertFailed = true;
      return (0);
   }
   
   //     -   
   
   if ((countBuy == 0) && (countSell == 0) && (countBuyStop != countSellStop))
   {
      WmCloseAllOrders(MagicNumber);
      return (0);
   }
   
   if (DoComments)
   {   
      Comment(
         "  : ", orders,
         "  : ", DoubleToStr(profit, 2), 
         "  : ", DoubleToStr(equity, 2), 
         " (", DoubleToStr(drilldown, 1), "%)");
   }

   double lot;

   //         ,    
   
   if (orders == 0)
   {
      RefreshRates();
      priceBuy = NormalizeDouble(Ask + ((ChannelPipsD5 / 2) * Point), Digits);
      priceSell = NormalizeDouble(Bid - ((ChannelPipsD5 / 2) * Point), Digits);
      WmOrderSend(Symbol(), OP_BUYSTOP, Lots, priceBuy, 0.0, 0.0, "", MagicNumber);
      WmOrderSend(Symbol(), OP_SELLSTOP, Lots, priceSell, 0.0, 0.0, "", MagicNumber);
      return (0);
   }
   else
   {
      //   ,   
      
      if ((countBuyStop == 0) || (countSellStop == 0))
      {
         if ((countBuyStop == 0) && (countSellStop > 0))
         {
            lot = (lotsBuy * 2.0) - lotsSell;
            if (lot >= Lots)
            {
               if ((lotsSell + lot) <= MaxLots)
               {
                  WmOrderSend(Symbol(), OP_SELLSTOP, lot, priceSell, 0.0, 0.0, "", MagicNumber);
                  return (0);
               }
            }
         }
         else
         {
            if ((countBuyStop > 0) && (countSellStop == 0))
            {
               lot = (lotsSell * 2.0) - lotsBuy;
               if (lot >= Lots)
               {
                  if ((lotsBuy + lot) <= MaxLots)
                  {
                     WmOrderSend(Symbol(), OP_BUYSTOP, lot, priceBuy, 0.0, 0.0, "", MagicNumber);
                     return (0);
                  }
               }
            }
            else
            {
               if ((countBuyStop == 0) && (countSellStop == 0))
               {
                  if (lotsBuy > lotsSell)
                  {
                     lot = (lotsBuy * 2.0) - lotsSell;
                     if (lot >= Lots)
                     {
                        if ((lotsSell + lot) <= MaxLots)
                        {
                           WmOrderSend(Symbol(), OP_SELLSTOP, lot, priceSell, 0.0, 0.0, "", MagicNumber);
                           return (0);
                        }
                     }
                  }
                  else
                  {
                     if (lotsBuy < lotsSell)
                     {
                        lot = (lotsSell * 2.0) - lotsBuy;
                        if (lot >= Lots)
                        {
                           if ((lotsBuy + lot) <= MaxLots)                           
                           {
                              WmOrderSend(Symbol(), OP_BUYSTOP, lot, priceBuy, 0.0, 0.0, "", MagicNumber);
                              return (0);
                           }
                        }
                     }
                  }
               }
            }
         }
      }
   }
   
   //    
   
   if (!WmIsNewBar())
   {
      return (0);   
   }

   //        - 

   if (profit > 5.0)
   {
      WmCloseAllOrders(MagicNumber);
      return (0);      
   }   
 
   return (0);  
}

//+------------------------------------------------------------------+
//|                                       |
//+------------------------------------------------------------------+

bool WmExistOrderTicket(string symbol, int magic, int ticket)
{
   for (int orderIndex = (OrdersTotal() - 1); orderIndex >= 0; orderIndex--)
   {
      if (!OrderSelect(orderIndex, SELECT_BY_POS))
      {
         continue;
      }

      if (OrderSymbol() != Symbol())
      {
         continue;
      }
      
      if (OrderMagicNumber() != magic)
      {
         continue;
      }

      if (OrderTicket() != ticket)
      {
         continue;
      }
      
      return (true);
   }
  
   return (false);
}


//+------------------------------------------------------------------+
//|                                            |
//+------------------------------------------------------------------+

void WmClearAndDraw(int magic)
{
   for (int indexObject = (ObjectsTotal() - 1); indexObject >= 0; indexObject--)
   {
      string nameObject = ObjectName(indexObject);
      int firstChar = StringGetChar(nameObject, 0);
      if (firstChar != '#')
      {
         continue;
      }
      
      int posSpace = StringFind(nameObject, " ");
      if (posSpace < 2)
      {
         continue;
      }
      
      string strTicket = StringSubstr(nameObject, 1, posSpace - 1);
      int ticket = StrToInteger(strTicket);
      if (!WmExistOrderTicket(Symbol(), magic, ticket))
      {
         ObjectDelete(nameObject);
      }
   }
   
   for (int indexOrder = 0; indexOrder < OrdersHistoryTotal(); indexOrder++)
   {
      if (!OrderSelect(indexOrder, SELECT_BY_POS, MODE_HISTORY))
      {
         continue;
      }
      
      if (OrderSymbol() != Symbol())
      {
         continue;
      }
   
      if ((OrderMagicNumber() != magic))
      {
         continue;
      }
      
      int orderType = OrderType();
      if ((orderType != OP_BUY) && (orderType != OP_SELL))
      {
         continue;
      }
      
      color clr;
      if (orderType == OP_BUY)
      {
         clr = ColorBuy;
      }
      else
      {
         clr = ColorSell;
      }

      strTicket = DoubleToStr(OrderTicket(), 0);      
      string strOpen = WindowExpertName() + "s" + strTicket;
      if (ObjectFind(strOpen) == -1)
      {
         ObjectCreate(strOpen, OBJ_ARROW, 0, OrderOpenTime(), OrderOpenPrice());
         ObjectSet(strOpen, OBJPROP_ARROWCODE, 1);
         ObjectSet(strOpen, OBJPROP_COLOR, clr);
      }
      
      string strTrend = WindowExpertName() + "t" + strTicket;
      if (ObjectFind(strTrend) == -1)
      {
         ObjectCreate(strTrend, OBJ_TREND, 0, OrderOpenTime(), OrderOpenPrice(), OrderCloseTime(), OrderClosePrice());
         ObjectSet(strTrend, OBJPROP_STYLE, STYLE_DOT);
         ObjectSet(strTrend, OBJPROP_WIDTH, 1);
         ObjectSet(strTrend, OBJPROP_COLOR, clr);
         ObjectSet(strTrend, OBJPROP_RAY, false);
      }      
      
      string strClose = WindowExpertName() + "f" + strTicket;
      if (ObjectFind(strClose) == -1)
      {
         ObjectCreate(strClose, OBJ_ARROW, 0, OrderCloseTime(), OrderClosePrice());
         ObjectSet(strClose, OBJPROP_ARROWCODE, 3);
         ObjectSet(strClose, OBJPROP_COLOR, clr);
      }
   }
}

//+------------------------------------------------------------------+
//|                                       |
//+------------------------------------------------------------------+

string WmGetNameTF(int timeFrame)
{
   switch (timeFrame)
   {
      case PERIOD_M1:  return ("M1");
      case PERIOD_M5:  return ("M5");
      case PERIOD_M15: return ("M15");
      case PERIOD_M30: return ("M30");
      case PERIOD_H1:  return ("H1");
      case PERIOD_H4:  return ("H4");
      case PERIOD_D1:  return ("Daily");
      case PERIOD_W1:  return ("Weekly");
      case PERIOD_MN1: return ("Monthly");
      default:         return (DoubleToStr(timeFrame, 0));
   }
}

//+------------------------------------------------------------------+
//|                                                   |
//+------------------------------------------------------------------+

void WmLoadHistory(int period = 0)

{
   int iPeriod[9];
   iPeriod[0] = PERIOD_M1;
   iPeriod[1] = PERIOD_M5;
   iPeriod[2] = PERIOD_M15;
   iPeriod[3] = PERIOD_M30;
   iPeriod[4] = PERIOD_H1;
   iPeriod[5] = PERIOD_H4;
   iPeriod[6] = PERIOD_D1;
   iPeriod[7] = PERIOD_W1;
   iPeriod[8] = PERIOD_MN1;
   for (int i = 0; i < 9; i++)
   {
      if ((period != 0) && (period != iPeriod[i]))
      {
         continue;
      }
   
      double open = iTime(Symbol(), iPeriod[i], 0);
      int error = GetLastError();
      while (error == ERR_HISTORY_WILL_UPDATED)
      {
         Print("Data for symbol ", Symbol(), " ", WmGetNameTF(iPeriod[i]), " not loaded. Loading data...");
         Sleep(10000);
         open = iTime(Symbol(), iPeriod[i], 0);
         error = GetLastError();
      }
   }
}

//+------------------------------------------------------------------+
//|                                          |
//+------------------------------------------------------------------+

void WmCloseAllOrders(int magic)
{
   for (int orderIndex = (OrdersTotal() - 1); orderIndex >= 0; orderIndex--)
   {
      if (!OrderSelect(orderIndex, SELECT_BY_POS))
      {
         continue;
      }

      if (OrderSymbol() != Symbol())
      {
         continue;
      }
      
      if (OrderMagicNumber() != magic)
      {
         continue;
      }

      WmCloseSelectedOrder();
   }
}

//+------------------------------------------------------------------+
//|                                         |
//+------------------------------------------------------------------+

string WmGetNameOP(int cmd)
{
   switch (cmd)
   {
      case OP_BUY      : return ("Buy");
      case OP_SELL     : return ("Sell");
      case OP_BUYLIMIT : return ("Buy Limit");
      case OP_SELLLIMIT: return ("Sell Limit");
      case OP_BUYSTOP  : return ("Buy Stop");
      case OP_SELLSTOP : return ("Sell Stop");
      default          : return (DoubleToStr(cmd, 0));
   }
}

//+------------------------------------------------------------------+
//|                                          |
//+------------------------------------------------------------------+

void WmCloseSelectedOrder(double volume = 0.0)
{
   color clr;
   double price;
   bool result;
   int error;   

   for (int try = 1; try <= NumberOfTry; try++)
   {
      if (!IsTesting() && (!IsExpertEnabled() || IsStopped())) 
      {
         break;
      }
      
      while (!IsTradeAllowed()) 
      {
         Sleep(5000);
      }
      
      if ((OrderType() == OP_BUY) || (OrderType() == OP_SELL))
      {
         RefreshRates();
         if (OrderType() == OP_BUY)
         {
            price = Bid; 
            clr = ColorBuy;
         } 
         else
         {
            price = Ask; 
            clr = ColorSell;
         }

         if (volume == 0.0)
         {
            volume = OrderLots();
         }
      
         result = OrderClose(OrderTicket(), volume, price, SlipPipsD5, clr);
      }
      else
      {
         result = OrderDelete(OrderTicket());
      }
      
      if (result)
      {
         if (DoSound) 
         {
            PlaySound("expert.wav");
            break;
         }
      } 
      else
      {
         error = GetLastError();
         if (error == ERR_TRADE_CONTEXT_BUSY) 
         {
            while (IsTradeContextBusy()) 
            {
               Sleep(10000);
            }
         }
      
        Print("Error(", error, ") Close ", WmGetNameOP(OrderType()), " ", ErrorDescription(error), ", try ", try);
        Print(OrderTicket(), "  Ask=", Ask,"  Bid=", Bid, "  price=", price);
        Print("symbol=", OrderSymbol(),"  volume=", OrderLots(),"  stoploss=", OrderStopLoss(), "  takeprofit=", OrderTakeProfit(),"  magic=", OrderMagicNumber());
        Sleep(5000);
      }
   }
}

//+------------------------------------------------------------------+
//|                                       |
//+------------------------------------------------------------------+

bool WmExistOrders(string symbol, int cmd, int magic, datetime opentime = 0)
{
   for (int orderIndex = (OrdersTotal() - 1); orderIndex >= 0; orderIndex--)
   {
      if (!OrderSelect(orderIndex, SELECT_BY_POS))
      {
         continue;
      }

      if (OrderSymbol() != Symbol())
      {
         continue;
      }
      
      if (OrderMagicNumber() != magic)
      {
         continue;
      }

      if (OrderType() != cmd)
      {
         continue;
      }
      
      if (opentime <= OrderOpenTime()) 
      {
         return (true);
      }
   }
  
   return (false);
}

//+------------------------------------------------------------------+
//|                                                   |
//+------------------------------------------------------------------+

void WmOrderSend(string symbol, int cmd, double volume, double price, double stoploss, double takeprofit, string comment, int magic, datetime expiration = 0)
{
   color clr;
   datetime opentime;
   int ticket;
   int error;
  
   comment = WindowExpertName() + " " + WmGetNameTF(Period()) + " " + comment;
   int msl = MarketInfo(symbol, MODE_STOPLEVEL);
   clr = CLR_NONE;
   if ((cmd == OP_BUY) || (cmd == OP_BUYSTOP))
   {
      clr = ColorBuy;
   }
   else if ((cmd == OP_SELL) || (cmd == OP_SELLSTOP))
   {
      clr = ColorSell;
   }
   
   if ((expiration > 0) && (expiration < TimeCurrent())) 
   {
      expiration = 0;
   }
  
   for (int try = 1; try <= NumberOfTry; try++)
   {
      if (!IsTesting() && (!IsExpertEnabled() || IsStopped()))
      {
         break;
      }
   
      while (!IsTradeAllowed()) 
      {
         Sleep(5000);
      }
    
      opentime = TimeCurrent();
      RefreshRates();
      if (cmd == OP_BUY)
      {
         price = Ask;
      }
      
      if (cmd == OP_SELL)
      {
         price = Bid;
      }
      
      ticket = OrderSend(symbol, cmd, volume, price, SlipPipsD5, stoploss, takeprofit, comment, magic, expiration, clr);
      if (ticket > 0)
      {
         if (DoSound) 
         {
            PlaySound("ok.wav"); 
         }
         
         break;
      } 
      else
      {
         error = GetLastError();
         if ((error == ERR_PRICE_CHANGED) || (error == ERR_REQUOTE)) 
         {
            continue;
         }
         
         if (error == ERR_TRADE_TIMEOUT)
         {
            Sleep(1000*66);
            if (WmExistOrders(symbol, cmd, magic, opentime))
            {
               if (DoSound) 
               {
                  PlaySound("ok.wav"); 
               }
               
               break;
            }
         }
        
         Print("Error(", error, ") set order: ", ErrorDescription(error), ", try ", try);
         Print(
            "Ask=", DoubleToStr(Ask, Digits), 
            "  Bid=", DoubleToStr(Bid, Digits),
            "  symbol=", symbol, 
            "  volume=", volume, 
            "  cmd=", WmGetNameOP(cmd), 
            "  price=", DoubleToStr(price, Digits), 
            "  stoploss=", DoubleToStr(stoploss, Digits), 
            "  takeprofit=", DoubleToStr(takeprofit, Digits), 
            "  magic=", magic);
         
         if (error == ERR_INVALID_STOPS)
         {
            Print ("MODE_STOPLEVEL = ", MarketInfo(Symbol(), MODE_STOPLEVEL));
            break;
         }                  
         
         if (error == ERR_INVALID_TRADE_VOLUME)
         {
            IsExpertFailed = true;
            break;
         }         
         
         if ((error == ERR_COMMON_ERROR) || (error == ERR_ACCOUNT_DISABLED) || (error == ERR_INVALID_ACCOUNT) || (error == ERR_TRADE_DISABLED))
         {
            IsExpertFailed = true;
            break;
         }
      
         if ((error == ERR_SERVER_BUSY) || (ERR_INVALID_TRADE_VOLUME) || (error == ERR_MARKET_CLOSED))
         {
            Sleep(1000*300); 
            break;
         }
      
         if ((error == ERR_TOO_FREQUENT_REQUESTS) || (error == ERR_TOO_MANY_REQUESTS)) 
         {
            Sleep(1000*100);
         }
      
         if ((error == ERR_ORDER_LOCKED) || (error == ERR_LONG_POSITIONS_ONLY_ALLOWED) || (error == ERR_TRADE_TOO_MANY_ORDERS)) 
         {
            break;
         }
      
         if (error == ERR_TRADE_CONTEXT_BUSY) 
         {
            while (IsTradeContextBusy()) 
            {
               Sleep(1000*11);
            }
        }
      
         if (error == ERR_TRADE_EXPIRATION_DENIED )
         {
            expiration = 0; 
            continue;
         }
         
         Sleep(5000);
      }
   }      
}


//+------------------------------------------------------------------+
//|   ?                                                |
//+------------------------------------------------------------------+

bool WmIsNewBar()
{
   static int prevTime = 0;

   int currentTime = iTime(NULL, 0, 0);
   if (prevTime == currentTime)
   {
      return (false);
   }

   prevTime = currentTime;
   return (true);
}